<template>
  <el-breadcrumb class="app-breadcrumb" separator="/">
    <transition-group name="breadcrumb">
      <el-breadcrumb-item v-for="(item,index) in levelList" :key="item.path">
        <span
          v-if="item.meta.redirect==='noRedirect'||index==levelList.length-1"
          class="no-redirect"
        >{{ getLocalizedTitle(item.meta.title, $store) }}</span>
        <n-link v-else :to="item.path">{{ getLocalizedTitle(item.meta.title, $store) }}</n-link>
      </el-breadcrumb-item>
    </transition-group>
  </el-breadcrumb>
</template>

<script>

import { fillMeta, getLocalizedTitle } from "@/utils/helpers"

export default {
  data() {
    return {
      levelList: null
    };
  },
  watch: {
    $route() {
      let lang = this.$store.getters['lang']
      // fill route matched with sidebar items metadata
      for (let i = 0; i < this.$route.matched.length; i++) {
        const r = this.$route.matched[i];
        if (lang != 'es') {
          r.path = r.path.replace(`/${lang}/`, `/`)
        }
        fillMeta(r);
      }
      this.getBreadcrumb();
    }
  },
  created() {
    let lang = this.$store.getters['lang']
    // fill route matched with sidebar items metadata
    for (let i = 0; i < this.$route.matched.length; i++) {
      const r = this.$route.matched[i];
      if (lang != 'es') {
        r.path = r.path.replace(`/${lang}/`, `/`)
      }
      fillMeta(r);
    }
    this.getBreadcrumb();
  },
  methods: {
    getLocalizedTitle,
    getBreadcrumb() {
      // only show routes with meta.title
      let matched = this.$route.matched.filter(
        item => item.meta && item.meta.title
      );

      const first = matched[0];

      if (!this.isDashboard(first)) {
        matched = [{ path: "/", meta: { title: { es: 'Inicio', en: 'Home' } } }].concat(
          matched
        );
      }

      this.levelList = matched.filter(
        item => item.meta && item.meta.title && item.meta.breadcrumb !== false
      );

    },
    isDashboard(route) {
      const name = route && route.name;

      if (!name) {
        return false;
      }

      return name
        .trim()
        .toLocaleLowerCase()
        .includes("index___".toLocaleLowerCase()); // name___ means nuxt routing notation
    }
  }
};
</script>

<style lang="scss" scoped>
.app-breadcrumb.el-breadcrumb {
  display: inline-block;
  font-size: 14px;
  line-height: 50px;
  margin-left: 8px;

  .no-redirect {
    color: #97a8be;
    cursor: text;
  }
}
</style>
